//+------------------------------------------------------------------+
//| This MQL is generated by Expert Advisor Builder                  |
//|                http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/ |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#property copyright "Expert Advisor Builder"
#property link      "http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/"

extern int MagicNumber = 1;
extern bool SignalMail = False;
extern bool EachTickMode = True;
extern double Lots = 0.01;
extern int Slippage = 50;
extern bool UseStopLoss = True;
extern int StopLoss = 1000;
extern bool UseTakeProfit = True;
extern int TakeProfit = 90000;
extern bool UseTrailingStop = True;
extern int TrailingStop = 30;

int BarCount;
int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;



   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+

double adx3 = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_PLUSDI, Current + 2);
double adx4 = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_MINUSDI, Current + 2);
double atr1 = iATR(NULL, 0, 14, 1);
double stocha8a = iStochastic(NULL, 0, 8, 3, 3, MODE_SMA, 1, MODE_MAIN, Current + 1);
double stocha8b = iStochastic(NULL, 0, 8, 3, 3, MODE_SMA, 1, MODE_SIGNAL, Current + 1);
double sar = iSAR(NULL, 0, 0.02, 0.2, Current + 0);
double stocha5a = iStochastic(NULL, 0, 5, 3, 3, MODE_SMA, 1, MODE_MAIN, Current + 1);
double stocha5b = iStochastic(NULL, 0, 5, 3, 3, MODE_SMA, 1, MODE_SIGNAL, Current + 1);
double adm1 = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_MAIN, 1);
double adm2 = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_MAIN, 2);
double adm3 = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_MAIN, 3);


double osma1 = iOsMA(NULL, 0, 12, 26, 9, PRICE_CLOSE, 1);
double osma2 = iOsMA(NULL, 0, 12, 26, 9, PRICE_CLOSE, 2);
double sd1 = iStdDev(NULL,0,14,0,MODE_EMA,PRICE_CLOSE,1);
double sd2 = iStdDev(NULL,0,14,0,MODE_EMA,PRICE_CLOSE,2);
double sd3 = iStdDev(NULL,0,14,0,MODE_EMA,PRICE_CLOSE,3);
double adx1 = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_PLUSDI, Current + 1);
double adx2 = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_MINUSDI, Current + 1);
double macd1 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, Current + 1);
double macd2 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, Current + 2);
double sar1 = iSAR(NULL, 0, 0.02, 0.2, Current + 1);
double stocha14a = iStochastic(NULL, 0, 14, 3, 3, MODE_SMA, 1, MODE_MAIN, Current + 1);
double stocha14b = iStochastic(NULL, 0, 14, 3, 3, MODE_SMA, 1, MODE_SIGNAL, Current + 1);
double wpr = iWPR(NULL, 0, 14, Current + 1);


   
   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      IsTrade = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

                     if (OrderMagicNumber() == MagicNumber && ((Open[1] > Close[1] && Open[0] > Close[0]) || Close[0] <= Low[1])) Order = SIGNAL_CLOSEBUY;


            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
            IsTrade = OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Close[0] > OrderStopLoss()) {
                  if(OrderStopLoss() < (Bid - atr1)) {
                     IsTrade = OrderModify(OrderTicket(), OrderOpenPrice(), Bid - atr1, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

                     if (OrderMagicNumber() == MagicNumber && ((Open[1] < Close[1] && Open[0] < Close[0]) || Close[0] >= High[1])) Order = SIGNAL_CLOSESELL;


            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               IsTrade = OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Close[0] < OrderStopLoss()) {
                  if((OrderStopLoss() > (Ask + atr1)) || (OrderStopLoss() == 0)) {
                     IsTrade = OrderModify(OrderTicket(), OrderOpenPrice(), Ask + atr1, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   } 

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

   if (Open[0]<Close[0] && ((Open[1]>Close[1] && Close[0]>=High[1] && (High[0]-High[1])<atr1) || (Open[1]<Close[1] && (High[0]-Open[0])<atr1 && (adx1>adx2 || (adx1<adx2 && adm1<adm2)) && ((((stocha5a>stocha5b && (stocha8a>stocha8b || stocha14a>stocha14b) && (osma1>osma2 || macd1>macd2)) || (stocha8a>stocha8b && (stocha5a>stocha5b || stocha14a>stocha14b) && (osma1>osma2 || macd1>macd2)) || (stocha14a>stocha14b && (stocha8a>stocha8b || stocha5a>stocha5b) && (osma1>osma2 || macd1>macd2)) || (osma1>osma2 && macd1>macd2))))))) Order = SIGNAL_BUY;

   if (Open[0]>Close[0] && ((Open[1]<Close[1] && Close[0]<=Low[1] && (Low[1]-Low[0])<atr1) || (Open[1]>Close[1] && (Open[0]-Low[0])<atr1 && (adx1<adx2 || (adx1>adx2 && adm1<adm2)) && ((((stocha5a<stocha5b && (stocha8a<stocha8b || stocha14a<stocha14b) && (osma1<osma2 || macd1<macd2)) || (stocha8a<stocha8b && (stocha5a<stocha5b || stocha14a<stocha14b) && (osma1<osma2 || macd1<macd2)) || (stocha14a<stocha14b && (stocha8a<stocha8b || stocha5a<stocha5b) && (osma1<osma2 || macd1<macd2)) || (osma1<osma2 && macd1<macd2))))))) Order = SIGNAL_SELL;

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (0.01 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, Bid - atr1, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (0.01 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, Ask + atr1, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}
//+------------------------------------------------------------------+